/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_dialogo(){
	contexto.save();
	
	//Dibujamos el marco
	var gradiente = contexto.createRadialGradient(dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 20, dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 200);
	gradiente.addColorStop(0, "#8ED6FF");
	gradiente.addColorStop(1, "#004CB3");
	contexto.fillStyle = gradiente;
	contexto.beginPath();
	contexto.rect(dialogo.x, dialogo.y, dialogo.w, dialogo.h);
	contexto.closePath();
	contexto.fill();		
		
	//Dibujamos el mensaje del dialogo	
	
	//Definimos las sombras
	contexto.shadowOffsetX = 5;
	contexto.shadowOffsetY = 5;
	contexto.shadowBlur = 5;
	contexto.shadowColor = '#666';
	
	contexto.fillStyle="#000000";
	dialogo.texto.dibujar(0,0);
	
	//Dibujamos las opciones
	
	var i;
	for(i=0;i<dialogo.coordenadas_opciones.length;i++){
		var gradiente = contexto.createRadialGradient(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 20,
														dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 300);		
		if(i==dialogo.opcion_apuntada){
			gradiente.addColorStop(0, "#F8FFAF");
			gradiente.addColorStop(1, "#6ED500");
		}else{
			gradiente.addColorStop(0, "#D6FF8E");
			gradiente.addColorStop(1, "#4CB300");
		}
		contexto.fillStyle = gradiente;

		contexto.beginPath();
		roundRect(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], dialogo.opcion_w, dialogo.opcion_h, 25);
		
		contexto.fill();
	}
	
	//Dibujamos el texto de las opciones
	contexto.fillStyle = "#000000"; // Color del texto
	contexto.fillText("Aceptar", dialogo.coordenadas_opciones[0][0]+15, dialogo.coordenadas_opciones[0][1]+30);
	
	if(dialogo.tag==0)
		contexto.fillText("Cancelar", dialogo.coordenadas_opciones[1][0]+10, dialogo.coordenadas_opciones[1][1]+30);
	
	
	contexto.restore();
}

function dibujar_jugador(){
	//Dibujamos al jugador
	contexto.drawImage(jugador.cara_img, jugador.getXCara(), jugador.getYCara(), jugador.cara_w, jugador.cara_h);
	contexto.drawImage(jugador.cuerpo_img[0], jugador.x, jugador.y, jugador.cuerpo_width, jugador.cuerpo_height);
	contexto.fillStyle="#FFFFFF";
	contexto.font = "bold 20px Comic Sans";
	contexto.fillText(jugador.nombre, jugador.x+40,jugador.y+200);	
}

function dibujar_depurar(){
	
	contexto.save();
	//Showing the grid
	contexto.strokeStyle = '#F0F'; // Color
	for(i=0;i<GRID_ROWS;i++){
		contexto.beginPath();
		contexto.moveTo(0,TAM_GRID_SQUARE_Y*i);
		contexto.lineTo(ANCHURA_VENTANA,TAM_GRID_SQUARE_Y*i);
		contexto.closePath();
		contexto.stroke();
	}
	
	for(i=0;i<GRID_COLUMNS;i++){
		contexto.beginPath();
		contexto.moveTo(TAM_GRID_SQUARE_X*i,0);
		contexto.lineTo(TAM_GRID_SQUARE_X*i,ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	contexto.restore();
}

function draw_fadein(){
	if(fadein_alpha>0.0){
		contexto.save();
		contexto.globalAlpha=fadein_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadein_alpha-=FADE_SPEED;
		contexto.restore();
		if(fadein_alpha<=0.0){
			//Inicializamos las bandas
			desbloquear();
		}
	}
}

function draw_fadeout(){
	if(fadeout_alpha<1.0){
		contexto.save();
		contexto.globalAlpha=fadeout_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadeout_alpha+=FADE_SPEED;
		contexto.restore();
		if(fadeout_alpha>=1.0){
			contexto.globalAlpha=0.0;
			redireccionar(url_redireccionar);
		}
	}
}