/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Jugador (){ 
	//Propiedades
	
	//Cuerpo
	this.x;
	this.y;
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = URL_IMAGENES+ "bodys/cuerpo.png";
	this.cuerpo_width=25*ESCALA_GENERAL;
	this.cuerpo_height=35*ESCALA_GENERAL;
	this.xref=Math.round(this.cuerpo_width/2);
	this.yref=Math.round(this.cuerpo_height);
	this.escala=1;

	//Cara
	this.cara_img=new Image();
	this.cara_img.src=URL_IMAGENES+"faces/{{ appearance.resource.id }}.{{ appearance.resource.type }}";
	this.cara_xref=myround({{ appearance.face_x }}*{{ appearance.escala }}); //x respecto al cuerpo
	this.cara_yref=myround({{ appearance.face_y }}*{{ appearance.escala }}); //y respecto al cuerpo
	this.cara_w=myround({{ appearance.face_w }}*{{ appearance.escala }});
	this.cara_h=myround({{ appearance.face_h }}*{{ appearance.escala }});

	//Rastro
	this.rastro_img=new Image();
	this.rastro_img.src = URL_IMAGENES+"interface/rastro.png";
	this.xrastro;
	this.yrastro;
	this.rastro_tam=myround(5*ESCALA_GENERAL);
	this.rastro_alpha=0.0;
	
	//Sombra
	this.sombra_img=new Image();
	this.sombra_img.src = URL_IMAGENES+"interface/sombra.png";
	this.sombra_xref=15;
	this.sombra_yref=155;
	this.wsombra=100;
	this.hsombra=30;
	
	//Movimiento
	this.direccion_x=0;
	this.direccion_y=0;
	
	//Metodos
	this.getX=function(){return myround(this.x+this.cuerpo_width*this.escala/2);}
	this.getY=function(){return myround(this.y+this.cuerpo_height*this.escala);}
	this.getXCara=function(){return myround(this.x+this.cara_xref*this.escala);}
	this.getYCara=function(){return myround(this.y+this.cara_yref*this.escala);}
	this.getXSombra=function(){return myround(this.x+this.sombra_xref*this.escala);}
	this.getYSombra=function(){return myround(this.y+this.sombra_yref*this.escala);}
}

function Escenario (){ 
	//Propiedades 
	this.fondo_img=new Image();
	this.fondo_img.src = URL_IMAGENES+"scenarios/fondo.jpg";
	this.xini=60*ESCALA_GENERAL;
	this.yini=50*ESCALA_GENERAL;
	
	this.area=new Array(3);
	this.area[0]=new Array(2);
	this.area[1]=new Array(2);
	this.area[2]=new Array(2);
	
	this.area[0][0]=Math.round(67*ESCALA_GENERAL);
	this.area[0][1]=Math.round(60*ESCALA_GENERAL);
	this.area[1][0]=Math.round(75*ESCALA_GENERAL);
	this.area[1][1]=Math.round(40*ESCALA_GENERAL);
	this.area[2][0]=Math.round(110*ESCALA_GENERAL);
	this.area[2][1]=this.area[1][1];
	
	//Objetos
	this.objetos=new Array();
	this.objetos[TAG_GUITAR]=new Array();
	this.objetos[TAG_AMP]=new Array();
	this.objetos[TAG_PHONE]=new Array();
	{% for model in models %}
		var tipo="{{ model.type }}";
		if(tipo=="guitarra"){
			this.objetos[TAG_GUITAR][this.objetos[TAG_GUITAR].length]=new Objeto("{{ model.brand }}_{{ model.name }}",90,50,10,30,1);
		}else if(tipo=="amp"){
			this.objetos[TAG_AMP][0]=new Objeto("{{ model.brand }}_{{ model.name }}",100,30,10,8,1);
		}
	{% endfor %}
	this.objetos[TAG_PHONE][0]=new Objeto("telefono",20,30,15,10,0);
	
	this.guitarra_activa=0;
}

function Ruta (xini,yini,xdes,ydes,area_actual,area_destino){
	//Propiedades 
	this.xcontrol;
	this.ycontrol;
	
	this.n_control=0;
	
	//Establecemos si hay riesgo de esquina
	if(area_actual!=area_destino){
		if(ydes<yini){ //Estoy subiendo
			if(area_destino<area_actual){ //Voy a la izquierda
				var xaux=xini;				
				if(escenario.area[area_destino][1]<escenario.area[area_actual][1]){ //El area es mayor
					while(posicion_relativa(escenario.area[area_destino][0],escenario.area[area_actual][1],xaux,yini,xdes,ydes)){
						xaux++;
					}
				}
					
				this.xcontrol=new Array(2);
				this.xcontrol[0]=xaux;
				this.xcontrol[1]=xdes;
				this.ycontrol=new Array(2);
				this.ycontrol[0]=yini;
				this.ycontrol[1]=ydes;
			}else{ //Voy a la derecha
				if(escenario.area[area_destino][1]<escenario.area[area_actual][1]){ //El area es mayor
					var xaux=xini;
					while(posicion_relativa(escenario.area[area_destino][0],escenario.area[area_actual][1],xaux,yini,xdes,ydes)){
						xaux++;
					}
					
					this.xcontrol=new Array(2);
					this.xcontrol[0]=xaux;
					this.xcontrol[1]=xdes;
					this.ycontrol=new Array(2);
					this.ycontrol[0]=yini;
					this.ycontrol[1]=ydes;
				}
			}
		}else{
			this.xcontrol=new Array(1);
			this.xcontrol[0]=xdes;
			this.ycontrol=new Array(1);
			this.ycontrol[0]=ydes;
		}
	}else{
		this.xcontrol=new Array(1);
		this.xcontrol[0]=xdes;
		this.ycontrol=new Array(1);
		this.ycontrol[0]=ydes;
	}
	
	this.finalizada=function(){
		if(this.n_control<this.xcontrol.length-1){
			this.n_control++;
			if(this.xcontrol[this.n_control]<jugador.getX())
				jugador.direccion_x=1;
			else if(this.xcontrol[this.n_control]>jugador.getX())
				jugador.direccion_x=2;
			if(this.ycontrol[this.n_control]<jugador.getY())
				jugador.direccion_y=1;
			else if(this.ycontrol[this.n_control]>jugador.getY())
				jugador.direccion_y=2;
			return false;
		}else return true;
	}

	this.getX=function(){return this.xcontrol[this.n_control];}
	this.getY=function(){return this.ycontrol[this.n_control];}
}

function Objeto(nombre,x,y,w,h,d){
	//Propiedades
	this.id=nombre;
	this.objeto_img=new Image();
	this.objeto_img.src=URL_IMAGENES+"objects/"+nombre+".png";
	this.x=myround(x*ESCALA_GENERAL);
	this.y=myround(y*ESCALA_GENERAL);
	this.width=myround(w*ESCALA_GENERAL);
	this.height=myround(h*ESCALA_GENERAL);
	this.draggable=d;
	this.dragged=0;
	this.escala=0.5+this.y/ALTURA_EFECTIVA;	
	
	//Sombra
	this.sombra_img=new Image();
	this.sombra_img.src = URL_IMAGENES+"interface/sombra.png";
	this.sombra_xref=15;
	this.sombra_yref=155;
	this.wsombra=100;
	this.hsombra=30;
	
	//Metodos
	this.getXSombra=function(){return this.x+this.sombra_xref*this.escala;}
	this.getYSombra=function(){return this.y+this.sombra_yref*this.escala;}
}

function Bocadillo(nombre,x,y,w,h){
	//Propiedades
	this.id=0;
        this.nombre=nombre;
	this.bocadillo_img=new Image();
	this.bocadillo_img.src=URL_IMAGENES+"interface/bocadillo_"+nombre+".png";
        this.x=x*ESCALA_GENERAL;
        this.y=y*ESCALA_GENERAL;
	this.width=w*ESCALA_GENERAL;
	this.height=h*ESCALA_GENERAL;
	this.bocadillo_alpha=0.0;
        this.estado=0;
        this.texto="";
	
	//Boton de cerrar
	this.cerrar_img=new Array(2);
	this.cerrar_img[0]=new Image();
	this.cerrar_img[0].src=URL_IMAGENES+"interface/cerrar.png";
	this.cerrar_img[1]=new Image();
	this.cerrar_img[1].src=URL_IMAGENES+"interface/cerrar2.png";
	this.cerrar_width=this.width/6;
	this.cerrar_height=this.cerrar_width;
	this.cerrar_x=this.x+this.width-this.cerrar_width;
	this.cerrar_y=this.y+this.cerrar_height;
}

function BandRequests(x,y){
    this.boton=new Boton("boton_sobre",myround(x*ESCALA_GENERAL),myround(y*ESCALA_GENERAL),myround(7*ESCALA_GENERAL),myround(4*ESCALA_GENERAL));
	this.requests=new Array(band_requests|length);
	var i=0;
	{% for band_request in band_requests %}
		this.requests[i]=new Array(2);
		this.requests[i][0]="{{ band_request.request_username }}";
		this.requests[i][1]="{{ band_request.band_name }}";
		i++;
	{% endfor %}
}

function ConcertRequests(x,y){
    this.boton=new Boton("boton_sobre",myround(x*ESCALA_GENERAL),myround(y*ESCALA_GENERAL),myround(7*ESCALA_GENERAL),myround(4*ESCALA_GENERAL));
	this.requests=new Array({{ concert_requests|length }});
	var i=0;
	{% for concert_request in concert_requests %}
		this.requests[i]=new Array(3);
		this.requests[i][0]="{{ concert_request.request_id }}";
		this.requests[i][1]="{{ concert_request.request_username }}";
		this.requests[i][2]="{{ concert_request.band_name }}";
		i++;
	{% endfor %}
}

function Dialogo(x,y,w,h,tag){
	
	this.tag=tag;
	if(tag!=-1){
		this.x=myround(x);
		this.y=myround(y);
		this.w=myround(w);
		this.h=myround(h);
		this.alpha=0.0;
		this.opcion_apuntada=-1;
		this.opcion_w=100;
		this.opcion_h=50;
		this.coordenadas_opciones=repartir_elementos(ANCHURA_VENTANA/2,y+h-h/3,2,2,this.opcion_w,this.opcion_h,50);
	}	
}
